<?php

/* XML-Log (c) 2002 by Andreas Jaggi aka X-Way 
*  Der XML-Log darf frei weitergegeben werden.
*  Jedoch drfen die Copyright Hinweise keinesfalls verndert werden!
*  Es darf nur die Original-Version des XML-Logs weitergegeben werden.
*  Das Kopieren von Teilbereichen des Quellcodes zur persnlichen Weiterbildung ist erlaubt.
*  
*  http://waterwave.ch/weblog
*/

$html = "";

/**
 * Diese Funktion behandelt ein ffnendes Element.
 * Alle Parameter werden automatisch vom Parser bergeben
 *
 * @param    parser    Object    Parserobjekt
 * @param    name      string    Name des ffnenden Elements
 * @param    atts      array     Array mit Attributen
 */
function startElement($parser, $name, $atts) {
  global $html;
  switch (strtolower($name)) {
  case "log":
    $html .= "<div><h2>Log von ".$atts["WEBSITE"]." seit ".$atts["STARTED"]."</h2>";
    break;
  case "entry";
    $html .= "<p>";
    break;
  case "referer":
    $html .= "Gekommen von : <b>";
    break;
case "time":
		$html .= "<b>";
    break;
case "useragent":
    $html .= " mit <b>";
    break;
  default:
    $error = "Undefiniertes Element <".$name.">";
    die($error . " in Zeile " . 
        xml_get_current_line_number($parser));
    break;
  }
}

/**
 * Diese Funktion behandelt ein abschlieendes Element
 * Alle Parameter werden automatisch vom Parser bergeben
 *
 * @param  parser    Object    Parserobjekt
 * @param  name      string    Name des schlieenden Elements
 */
function endElement($parser, $name) {
  global $html;
  switch (strtolower($name)) {
  case "log":
    $html .= "</div>";
    break;
case "referer":
    $html .= "</b>";
    break;
case "time":
    $html .= "</b> ";
    break;
case "useragent":
    $html .= "</b>";
    break;
case "entry":
    $html .= "</p>";
    break;
  }
}

/**
 * Diese Funktion behandelt normalen Text
 * Alle Parameter werden automatisch vom Parser bergeben
 *
 * @param    parser    Object    Parserobjekt
 * @param    text      string    Der Text
 */
function cdata($parser, $text) {
  global $html;
  $html .= $text;
}

// Die XML-Datei wird in die Variable $xmlFile eingelesen
$xmlFile = implode("", file("log.txt"));

// Der Parser wird erstellt
$parser = xml_parser_create();
// Setzen der Handler
xml_set_element_handler($parser,"startElement","endElement");
// Setzen des CDATA-Handlers
xml_set_character_data_handler($parser, "cdata");
// Parsen
xml_parse($parser, $xmlFile);
// Gibt alle verbrauchten Ressourcen wieder frei.
xml_parser_free($parser);

print $html;

?>
